#include<stdio.h>
#include<stdlib.h>

typedef struct list_entry_s
{
	int elt;
	struct list_entry_s *next;
	struct list_entry_s *prev;
}list_entry;

typedef struct list_s
{
	int size;
	list_entry *start;
	list_entry *end;
}list;

list* list_new();
list_entry* list_entry_new(int val);
void list_addAtHead(list *l, int val);
void list_addAtTail(list *l, int val);
void list_add(list *l, int val);
void list_free(list *l);
void list_print(list *l, FILE *stream);
list* list_union(list *l1, list *l2);
list* list_intersect(list *l1, list *l2);
list* list_merage(int mode, list *l1, list *l2);
list* list_minus(list *l1, list *l2);
